#include <iostream>
#include <iomanip>  // necessário para métodos setf() de cin e ostream's

using namespace std;

#ifndef MAT_TYPE
#define MAT_TYPE int
#endif

class Matrix {
  int linhas, colunas;
  MAT_TYPE **mat;

  Matrix add (const Matrix &mat_2, char op);
public:
  Matrix();
  Matrix(int lins, int cols);
  Matrix(MAT_TYPE **newmat, int lins, int cols);

  MAT_TYPE* operator [](const int j) const; // mat[x]
  Matrix operator +(const Matrix& mat2); // mat + mat_2
  Matrix operator -(const Matrix& mat2); // mat - mat_2
  Matrix operator *(const Matrix& mat2); // mat * mat_2
  Matrix operator *(const float escalar); // mat * escalar

  // Funções são amigas, mas não são parte da classe.
  friend istream& operator >>(istream& s, Matrix& m);
  friend ostream& operator <<(ostream& s, Matrix& m);
  friend Matrix operator *(const float escalar, Matrix& mat_1);  // escalar * mat
};
